<template>
  <div class="app-container">
    <el-row :gutter="20">
      <el-col :span="24">

        <user-statistics />

        <el-dialog title="Detail RW" :visible.sync="visibleDialog" @close="visibleDialog = false">
          <el-table :data="tableUser" :show-header="false" style="width: 100%">
            <el-table-column prop="title" />
            <el-table-column prop="content" />
          </el-table>

          <div v-if="isShowVerify" class="dialog-text" style="width: 100%">
            <div style="margin-top: 50px">
              <h3>{{ $t('label.sk-rw-heading') }}</h3>
            </div>
            <el-row v-if="file_sk_url" type="flex" class="row-panel bg-blue">
              <el-col :span="20" style="margin-top: 10px">
                <em class="el-icon-document" style="margin-right: 5px" />
                {{ $t('label.sk-rw-available') }}
              </el-col>
              <el-col :span="4">
                <el-button class="custom-attachment-button" @click="previewAttachment">
                  {{ $t('label.beneficiaries-upload-view') }}
                </el-button>
              </el-col>
            </el-row>
            <el-row v-else type="flex" class="row-panel bg-gray">
              <el-col :span="20" style="margin-top: 10px">
                <em class="el-icon-document-delete" style="margin-right: 5px" />
                {{ $t('label.sk-rw-empty') }}
              </el-col>
              <el-col :span="4">
                <el-button disabled>
                  {{ $t('label.beneficiaries-upload-view') }}
                </el-button>
              </el-col>
            </el-row>
          </div>

          <div slot="footer" class="dialog-footer">
            <el-button v-if="isShowVerify" type="primary" @click="verifyUser(), visibleDialog = false">
              {{ $t('crud.verified') }}
            </el-button>
            <el-button v-else type="primary" @click="visibleDialog = false">
              {{ $t('crud.back') }}
            </el-button>
          </div>
        </el-dialog>

        <el-row style="margin: 10px 0px">
          <router-link :to="{ path: '/user/create', query: { role_id: roleId }}">
            <el-button type="primary" size="small" icon="el-icon-plus">
              {{ $t('users.users-add-new') }}
            </el-button>
          </router-link>
        </el-row>

        <ListFilter
          :list-query.sync="listQuery"
          @change-kabkota="changeKabkota"
          @change-kecamatan="changeKecamatan"
          @change-kelurahan="changeKelurahan"
          @change-rw="changeRW"
          @submit-search="getList"
          @reset-search="resetFilter"
        />

        <el-table v-loading="listLoading" :data="list" border stripe fit highlight-current-row @sort-change="changeSort">
          <el-table-column type="index" fixed min-width="50" align="center" :index="getTableRowNumbering" />
          <el-table-column prop="name" fixed sortable="custom" :label="$t('users.users-fullname')" min-width="175" />
          <el-table-column v-if="!isActivedRW" prop="username" fixed sortable="custom" :label="$t('users.users-username')" min-width="175" />
          <el-table-column v-if="checkPermission(['admin', 'staffProv', 'staffKabkota'])" prop="kabkota.name" label="Kabupaten" min-width="175" />
          <el-table-column v-if="checkPermission(['admin', 'staffProv'])" prop="kecamatan.name" label="Kecamatan" min-width="175" />
          <el-table-column prop="kelurahan.name" label="Desa" min-width="175" />
          <el-table-column prop="rw" label="RW" min-width="80px" />
          <el-table-column v-if="!listQuery.is_verified" align="center" fixed="right" :label="$t('users.users-actions')" min-width="220">
            <template slot-scope="scope">
              <el-button v-if="isShowVerify" type="primary" size="small" @click="getDetail(scope.row.id)">
                {{ $t('crud.verified') }}
              </el-button>
              <el-tooltip v-if="isShowRegistrationDate" content="Detail" placement="top">
                <el-button type="primary" icon="el-icon-view" size="small" @click="getDetail(scope.row.id)" />
              </el-tooltip>
              <router-link v-if="isShowOtherActions" :to="'/user/edit/'+scope.row.id">
                <el-tooltip content="Edit" placement="top">
                  <el-button type="warning" size="small" icon="el-icon-edit" />
                </el-tooltip>
              </router-link>
              <el-tooltip v-if="isShowOtherActions && scope.row.status === 10" content="Nonaktifkan Pengguna" placement="top">
                <el-button type="danger" icon="el-icon-circle-close" size="small" @click="deactivateUser(scope.row.id)" />
              </el-tooltip>
              <el-tooltip v-if="isShowOtherActions" content="Chat User" placement="top">
                <el-button type="info" size="small" @click="onClickChat(scope.row.phone)">
                  <img alt="whatsapp" src="@/assets/gray-whatsapp.svg">
                </el-button>
              </el-tooltip>
            </template>
          </el-table-column>
          <el-table-column v-if="isShowVerifyDate" prop="is_verified_at" :label="$t('users.users-date-verified')" min-width="150" :formatter="formatterCell" />
          <el-table-column v-if="isShowRegistrationDate" prop="created_at" :label="$t('label.created-at')" min-width="150" :formatter="formatterCell" />
          <el-table-column v-if="isShowOtherActions" prop="status" class-name="status-col" :label="$t('users.users-status')" min-width="175">
            <template slot-scope="{row}">
              <el-tag :type="row.is_verified ? 'success' : 'warning'">
                {{ row.is_verified ? 'Terverifikasi' : 'Belum Terverifikasi' }}
              </el-tag>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { fetchList, fetchUser, verifikasi, deactivate } from '@/api/staff'
import Pagination from '@/components/Pagination'
import ListFilter from './_listfilterRW'
import checkPermission from '@/utils/permission'
import UserStatistics from './components/userStatistics'
import { parsingDatetime, formatDatetime, formatDatetimeUTC } from '@/utils/datetimeToString'

export default {
  components: { Pagination, ListFilter, UserStatistics },
  props: {
    roleId: {
      type: String,
      default: null
    }
  },
  data() {
    return {
      list: null,
      total: 0,
      listLoading: true,
      file_sk_url: null,
      listQuery: {
        name: null,
        username: null,
        phone: null,
        status: 10,
        kabkota_id: null,
        kec_id: null,
        kel_id: null,
        rw: null,
        role_id: this.roleId,
        profile_completed: null,
        last_access_start: '',
        last_access_end: '',
        sort_by: 'name',
        sort_order: 'ascending',
        page: 1,
        limit: 10,
        is_verified: '',
        is_verified_at: null,
        userId: null,
        file_sk_url: null
      },
      visibleDialog: false,
      tableUser: []
    }
  },
  computed: {
    isShowVerify() {
      if (this.$route.name === 'user-list-rw-unverified') {
        return true
      }
      return false
    },
    isShowOtherActions() {
      if (this.$route.name === 'user-list-rw-all') {
        return true
      }
      return false
    },
    isShowRegistrationDate() {
      if (!this.listQuery.is_verified && this.$route.name !== 'user-list-rw-unverified') {
        return true
      }
      return false
    },
    isShowVerifyDate() {
      if (this.listQuery.is_verified === 1) {
        return true
      }
      return false
    },
    isActivedRW() {
      return this.listQuery.status === 1
    }
  },
  created() {
    this.getList()
  },
  methods: {
    checkPermission,

    async getList() {
      this.listLoading = true
      if (this.$route.name === 'user-list-rw-verified') {
        this.listQuery.is_verified = 1
      }
      if (this.$route.name === 'user-list-rw-inactive') {
        this.listQuery.status = 1
      }
      if (this.$route.name === 'user-list-rw-all') {
        this.listQuery.is_verified = null
      }
      try {
        const response = await fetchList(this.listQuery)
        this.list = response.data.items
        this.total = response.data._meta.totalCount
        this.listLoading = false
      } catch (error) {
      // silent error
      }
    },

    resetFilter() {
      Object.assign(this.$data.listQuery, this.$options.data().listQuery)
      this.listQuery.role_id = this.roleId

      this.getList()
    },

    getTableRowNumbering(index) {
      return ((this.listQuery.page - 1) * this.listQuery.limit) + (index + 1)
    },

    changeSort(e) {
      this.listQuery.sort_by = e.prop
      this.listQuery.sort_order = e.order
      this.getList()
    },

    changeKabkota(id) {
      this.listQuery.kabkota_id = id
      this.listQuery.kec_id = null
      this.listQuery.kel_id = null
      this.listQuery.rw = null
    },

    changeKecamatan(id) {
      this.listQuery.kec_id = id
      this.listQuery.kel_id = null
      this.listQuery.rw = null
    },

    changeKelurahan(id) {
      this.listQuery.kel_id = id
      this.listQuery.rw = null
    },

    changeRW(id) {
      this.listQuery.rw = id
    },

    async getDetail(id) {
      try {
        const response = await fetchUser(id)
        const {
          name,
          kabkota,
          kecamatan,
          kelurahan,
          rw,
          file_sk_url,
          file_sk_url_uploaded_at,
          created_at
        } = response.data
        this.tableUser = [
          {
            title: this.$t('label.fullname'),
            content: name || '-'
          },
          {
            title: this.$t('label.area-kabkota'),
            content: kabkota?.name || '-'
          },
          {
            title: this.$t('label.area-kec'),
            content: kecamatan?.name || '-'
          },
          {
            title: this.$t('label.area-kel'),
            content: kelurahan?.name || '-'
          },
          {
            title: this.$t('label.area-rw'),
            content: rw || '-'
          },
          {
            title: this.isShowRegistrationDate ? this.$t('label.created-at') : this.$t('label.file-sk-uploaded-at'),
            content: this.isShowRegistrationDate ? this.formatDate(created_at) : formatDatetimeUTC(file_sk_url_uploaded_at, 'DD MMM YYYY HH:mm')
          }
        ]
        this.userId = id
        this.file_sk_url = file_sk_url
        this.visibleDialog = true
      } catch (error) {
      // silent error
      }
    },

    previewAttachment() {
      if (typeof this.file_sk_url === 'string' && this.file_sk_url.startsWith('http')) {
        window.open(this.file_sk_url, '_blank')
      }
    },

    async verifyUser() {
      try {
        await verifikasi(this.userId)
        this.$message({
          type: 'success',
          message: this.$t('crud.verification-success')
        })
        this.getList()
      } catch (error) {
      // silent error
      }
    },

    async deactivateUser(id) {
      try {
        await this.$confirm(this.$t('crud.user-deactivate-confirm'), 'Warning', {
          confirmButtonText: this.$t('common.confirm'),
          cancelButtonText: this.$t('common.cancel'),
          type: 'warning'
        })

        this.listLoading = true

        await deactivate(id)

        this.$message({
          type: 'success',
          message: this.$t('crud.deactivate-success')
        })

        this.getList()
      } catch (e) {
      // silent error
      }
    },

    formatDate(date) {
      if (this.isShowRegistrationDate) {
        return date ? parsingDatetime(date, 'DD MMM YYYY HH:mm') : '-'
      } else {
        return date ? formatDatetime(date, 'DD MMM YYYY HH:mm') : '-'
      }
    },

    formatterCell(row, column, cellValue, index) {
      return this.formatDate(cellValue)
    },

    onClickChat(phone) {
      const url_link = 'https://wa.me/' + phone.replace(/^0+/, '62')
      window.open(url_link, '_blank')
    }

  }
}
</script>

<style lang="scss" scoped>
  .row-panel {
    margin: auto;
    padding: 10px 20px;
    border-radius: 5px;
  }
  .bg-blue {
    background-color: #E3F2FD;
  }
 .bg-gray {
    background-color: #F5F5F5;
  }

  .custom-attachment-button {
    float: right;
    color: #1565C0;
    background-color: transparent;
  }
</style>
